! 1 
! 1 /*
! 2  * ps.c
! 3  *
! 4  * Copyright 1998 Alistair Riddoch
! 5  * ajr@ecs.soton.ac.uk
! 6  *
! 7  * This file may be distributed under the terms of the GNU General Public
! 8  * License v2, or at your option any later version.
! 9  */
! 10 
! 11 /*
! 12  * This is a small version of ps for use in the ELKS project.
! 13  * It is not fully functional, and it is not portable.
! 14  */
! 15 
! 16 #include <linuxmt/mem.h>
! 1 
! 1 #ifndef __LINUXMT_MOD_H__
! 2 #define __LINUXMT_MOD_H__
! 3 
! 4 #define DATASIZE 2048
! 5 #define TEXTSIZE 2048
! 6 
! 7 #define MOD_INIT	0
! 8 #define MOD_TERM	1
! 9 
! 10 #define MEM_GETMODTEXT	0
! 11 #define MEM_GETMODDATA	1
! 12 #define MEM_GETTEXTSIZ	2
! 13 #define MEM_GETTASK	2
! 14 #define MEM_GETDS	5
! 15 #define MEM_GETCS	6
! 16 
! 17 
! 18 extern char module_data[];
! 19 extern int module_init();
! 20 
! 21 #endif /* __LINUXMT_MOD_H_ */
! 22 
! 22 
! 23 
! 17 #include <linuxmt/sched.h>
! 1 
! 1 #ifndef __LINUXMT_SCHED_H__
! 2 #define __LINUXMT_SCHED_H__
! 3 
! 4 #define MAX_TASKS 15
! 5 #define NGROUPS	13		/* Supplementary groups */
! 6 #define NOGROUP 0xFFFF
! 7 #define KSTACK_BYTES 1024	/* Size of kernel stacks */
! 8 #define USTACK_BYTES 4096	/* Size of user-mode stacks */
! 9 
! 10 #include <linuxmt/fs.h>
! 1 
! 1 #ifndef __LINUXMT_FS_H__
! 2 #define __LINUXMT_FS_H__
! 3 
! 4 /*
! 5  * This file has definitions for some important file table
! 6  * structures etc.
! 7  */
! 8 
! 9 #include <linuxmt/wait.h>
! 1 
! 1 #ifndef __LINUX_WAIT_H__
! 2 #define __LINUX_WAIT_H__
! 3 
! 4 #define WNOHANG		0x00000001
! 5 #define WUNTRACED	0x00000002
! 6 
! 7 #define wake_up(_a) _wake_up(_a,1)
! 8 #define wake_up_interruptible(_a) _wake_up(_a,0)
! 9 
! 10 struct wait_queue {
! 11 	char pad;
! 12 };
! 13 
! 14 #ifdef __KERNEL__
! 15 
! 16 struct select_table_entry {
! 17 	struct wait_queue wait;
! 18 	struct wait_queue *wait_address;
! 19 };
! 20 
! 21 typedef struct select_table_struct {
! 22 	int nr;
! 23 	struct select_table_entry * entry;
! 24 } select_table;
! 25 
! 26 #define __MAX_SELECT_TABLE_ENTRIES 32
! 27 
! 28 #endif /* __KERNEL__ */
! 29 
! 30 #endif
! 31 
! 31 
! 32 
! 10 #include <linuxmt/types.h>
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 1 
! 1 /* arch/i86/include/asm/types.h - Basic Linux/MT data types. */
! 2 
! 3 #ifndef __ARCH_8086_TYPES__
! 4 #define __ARCH_8086_TYPES__
! 5 
! 6 /* First we define all of the __u and __s types...*/
! 7 
! 8 #define signed
! 9 
! 10 typedef unsigned char   __u8;
! 11 typedef unsigned char * __pu8;
! 12 typedef   signed char   __s8;
! 13 typedef   signed char * __ps8;
! 14 
! 15 typedef unsigned short int   __u16;
! 16 typedef unsigned short int * __pu16;
! 17 typedef   signed short int   __s16;
! 18 typedef   signed short int * __ps16;
! 19 
! 20 typedef unsigned long int   __u32;
! 21 typedef unsigned long int * __pu32;
! 22 typedef   signed long int   __s32;
! 23 typedef   signed long int * __ps32;
! 24 
! 25 /* __uint == 16bit here */
! 26 
! 27 typedef unsigned short int   __uint;
! 28 typedef unsigned short int * __puint;
! 29 typedef   signed short int   __sint;
! 30 typedef   signed short int * __psint;
! 31 
! 32 /* Then we define registers, etc... */
! 33 
! 34 struct _registers {
! 35 	__u16 ksp, sp, ss, ax, bx, cx, dx, di, si, ds, es, bp, ip, cs, flags;
! 36 };
! 37 
! 38 typedef __u16 flag_t;
! 39 
! 40 typedef struct _registers __registers; 
! 41 typedef struct _registers * __pregisters;
! 42 
! 43 typedef __u16 __pptr; /* Changed to short as that is what it is */
! 44 
! 45 struct _mminit {
! 46 	__u16 cs, endcs, ds, endds, ss, endss, lowss;
! 47 };
! 48 
! 49 typedef struct _mminit   __arch_mminit;
! 50 typedef struct _mminit * __parch_mminit;
! 51 
! 52 #ifndef NULL
! 53 #define NULL	0
! 54 #endif
! 55 
! 56 #endif
! 57 
! 57 
! 58 
! 5 #include <linuxmt/posix_types.h>
! 1 
! 1 #ifndef __LINUXMT_POSIX_TYPES_H__
! 2 #define __LINUXMT_POSIX_TYPES_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 1 
! 1 /*
! 2  * Automatically generated by make menuconfig: don't edit
! 3  */
! 4 #define AUTOCONF_INCLUDED
! 5 
! 6 /*
! 7  * Advanced - for Developers and Hackers only
! 8  */
! 9 #undef  CONFIG_EXPERIMENTAL
! 10 #undef  CONFIG_OBSOLETE
! 11 #undef  CONFIG_NOT_YET
! 12 
! 13 /*
! 14  * Architecture
! 15  */
! 16 #define CONFIG_ARCH_AUTO 1
! 17 #undef  CONFIG_ARCH_IBMPC
! 18 #undef  CONFIG_ARCH_SIBO
! 19 #define CONFIG_PC_AUTO 1
! 20 #undef  CONFIG_PC_XT
! 21 #undef  CONFIG_PC_AT
! 22 #undef  CONFIG_PC_MCA
! 23 #undef  CONFIG_ROMCODE
! 24 
! 25 /*
! 26  * 286 Protected Mode Support
! 27  */
! 28 #undef  CONFIG_286PMODE
! 29 
! 30 /*
! 31  * Driver Support
! 32  */
! 33 
! 34 /*
! 35  * Character device drivers
! 36  */
! 37 #define CONFIG_CONSOLE_DIRECT 1
! 38 #undef  CONFIG_CONSOLE_BIOS
! 39 #undef  CONFIG_CONSOLE_SERIAL
! 40 #define CONFIG_DCON_VT52 1
! 41 #define CONFIG_DCON_ANSI 1
! 42 #undef  CONFIG_DCON_ANSI_PRINTK
! 43 #define CONFIG_KEYMAP_US 1
! 44 #undef  CONFIG_KEYMAP_BE
! 45 #undef  CONFIG_KEYMAP_UK
! 46 #undef  CONFIG_KEYMAP_DE
! 47 #undef  CONFIG_KEYMAP_DV
! 48 #undef  CONFIG_KEYMAP_ES
! 49 #undef  CONFIG_KEYMAP_FR
! 50 #undef  CONFIG_KEYMAP_SE
! 51 #define CONFIG_DCON_KRAW 1
! 52 #define CONFIG_CHAR_DEV_RS 1
! 53 #define CONFIG_CHAR_DEV_LP 1
! 54 #define CONFIG_CHAR_DEV_MEM 1
! 55 #define CONFIG_PSEUDO_TTY 1
! 56 #undef  CONFIG_DEV_META
! 57 
! 58 /*
! 59  * Block device drivers
! 60  */
! 61 #define CONFIG_BLK_DEV_BIOS 1
! 62 #define CONFIG_BLK_DEV_BFD 1
! 63 #define CONFIG_BLK_DEV_BHD 1
! 64 #undef  CONFIG_BLK_DEV_FD
! 65 #undef  CONFIG_BLK_DEV_HD
! 66 #undef  CONFIG_BLK_DEV_XD
! 67 #undef  CONFIG_DMA
! 68 #define CONFIG_GENDISK 1
! 69 #undef  CONFIG_BLK_DEV_RAM
! 70 #define CONFIG_BLK_DEV_CHAR 1
! 71 
! 72 /*
! 73  * Filesystems
! 74  */
! 75 #define CONFIG_MINIX_FS 1
! 76 #undef  CONFIG_ROMFS_FS
! 77 #undef  CONFIG_ELKSFS_FS
! 78 #undef  CONFIG_FULL_VFS
! 79 #define CONFIG_FS_EXTERNAL_BUFFER 1
! 80 #define CONFIG_PIPE 1
! 81 #define CONFIG_EXEC_MINIX 1
! 82 #undef  CONFIG_EXEC_MSDOS
! 83 
! 84 /*
! 85  * Network Support
! 86  */
! 87 #define CONFIG_SOCKET 1
! 88 #undef  CONFIG_NANO
! 89 #define CONFIG_INET 1
! 90 #define CONFIG_INET_STATUS 1
! 91 #undef  CONFIG_UNIX
! 92 #undef  CONFIG_SOCK_CLIENTONLY
! 93 
! 94 /*
! 95  * Kernel hacking
! 96  */
! 97 #undef  CONFIG_STRACE
! 98 #undef  CONFIG_OPT_SMALL
! 99 
! 99 
! 100 
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 
! 6 /*
! 7  * This file is generally used by user-level software, so you need to
! 8  * be a little careful about namespace pollution etc.  Also, we cannot
! 9  * assume GCC is being used.
! 10  */
! 11 
! 12 #ifndef NULL
! 13 # define NULL		((void *) 0)
! 14 #endif
! 15 
! 16 /*
! 17  * This allows for 20 file descriptors: if NR_OPEN is ever grown
! 18  * beyond that you'll have to change this too. For now 20 fd's seem to be
! 19  * enough for ELKS, so hopefully this won't need changing.
! 20  *
! 21  * Note that POSIX wants the FD_CLEAR(fd,fdsetp) defines to be in
! 22  * <sys/time.h> (and thus <linux/time.h>) - but this is a more logical
! 23  * place for them. Solved by having dummy defines in <sys/time.h>.
! 24  */
! 25 
! 26 /*
! 27  * Those macros may have been defined in <gnu/types.h>. But we always
! 28  * use the ones here. 
! 29  */
! 30 
! 31 #ifdef CONFIG_SHORT_FILES
! 32 
! 33 #undef __NFDBITS
! 34 #define __NFDBITS	(8 * sizeof(unsigned short))
! 35 
! 36 #undef __FD_SETSIZE
! 37 #define __FD_SETSIZE	16
! 38 
! 39 typedef __u16 __kernel_fd_set;
! 40 
! 41 #else /* CONFIG_SHORT_FILES */
! 42 
! 43 #undef __NFDBITS
! 44 #define __NFDBITS	(8 * sizeof(unsigned long))
! 45 
! 46 #undef __FD_SETSIZE
! 47 #define __FD_SETSIZE	20
! 48 
! 49 typedef __u32 __kernel_fd_set;
! 50 
! 51 #endif /* CONFIG_SHORT_FILES */
! 52 
! 53 #include <arch/posix_types.h>
! 1 
! 1 #ifndef __ARCH_8086_POSIX_TYPES_H__
! 2 #define __ARCH_8086_POSIX_TYPES_H__
! 3 
! 4 #include <arch/irq.h>
! 1 
! 1 #ifndef __ARCH_8086_IRQ_H__
! 2 #define __ARCH_8086_IRQ_H__
! 3 
! 4 #include <arch/types.h>
! 1 
! 1 /* arch/i86/include/asm/types.h - Basic Linux/MT data types. */
! 2 
! 3 #ifndef __ARCH_8086_TYPES__
! 4 #define __ARCH_8086_TYPES__
! 5 
! 6 /* First we define all of the __u and __s types...*/
! 7 
! 8 #define signed
! 9 
! 10 typedef unsigned char   __u8;
! 11 typedef unsigned char * __pu8;
! 12 typedef   signed char   __s8;
! 13 typedef   signed char * __ps8;
! 14 
! 15 typedef unsigned short int   __u16;
! 16 typedef unsigned short int * __pu16;
! 17 typedef   signed short int   __s16;
! 18 typedef   signed short int * __ps16;
! 19 
! 20 typedef unsigned long int   __u32;
! 21 typedef unsigned long int * __pu32;
! 22 typedef   signed long int   __s32;
! 23 typedef   signed long int * __ps32;
! 24 
! 25 /* __uint == 16bit here */
! 26 
! 27 typedef unsigned short int   __uint;
! 28 typedef unsigned short int * __puint;
! 29 typedef   signed short int   __sint;
! 30 typedef   signed short int * __psint;
! 31 
! 32 /* Then we define registers, etc... */
! 33 
! 34 struct _registers {
! 35 	__u16 ksp, sp, ss, ax, bx, cx, dx, di, si, ds, es, bp, ip, cs, flags;
! 36 };
! 37 
! 38 typedef __u16 flag_t;
! 39 
! 40 typedef struct _registers __registers; 
! 41 typedef struct _registers * __pregisters;
! 42 
! 43 typedef __u16 __pptr; /* Changed to short as that is what it is */
! 44 
! 45 struct _mminit {
! 46 	__u16 cs, endcs, ds, endds, ss, endss, lowss;
! 47 };
! 48 
! 49 typedef struct _mminit   __arch_mminit;
! 50 typedef struct _mminit * __parch_mminit;
! 51 
! 52 #ifndef NULL
! 53 #define NULL	0
! 54 #endif
! 55 
! 56 #endif
! 57 
! 57 
! 58 
! 5 #define save_flags(x)	x=__save_flags()
! 6 
! 7 /* Who gets which entry in bh_base. Things which will occur most often
! 8    should come first - in which case NET should be up the top with
! 9    SERIAL/TQUEUE! */
! 10 
! 11 enum {
! 12         TIMER_BH = 0,
! 13         CONSOLE_BH,
! 14         TQUEUE_BH,
! 15         DIGI_BH,
! 16         SERIAL_BH,
! 17         RISCOM8_BH,
! 18         SPECIALIX_BH,
! 19         BAYCOM_BH,
! 20         NET_BH,
! 21         IMMEDIATE_BH,
! 22         KEYBOARD_BH,
! 23         CYCLADES_BH,
! 24         CM206_BH
! 25 };
! 26 
! 27 extern void disable_irq();
! 28 extern void enable_irq();
! 29 extern void do_IRQ();
! 30 extern flag_t __save_flags();
! 31 extern void restore_flags();
! 32 extern int request_irq();
! 33 extern void free_irq();
! 34 
! 35 #if 0
! 36 extern void icli();
! 37 extern void isti();
! 38 #endif
! 39 
! 40 extern void do_bottom_half();
! 41 
! 42 extern int bh_mask_count[16];
! 43 extern unsigned bh_active;
! 44 extern unsigned bh_mask;
! 45 extern void (*bh_base[16])();
! 46 
! 47 #ifdef __KERNEL__
! 48 #define icli() asm("cli")
! 49 #define isti() asm("sti")
! 50 #else __KERNEL__
! 51 #define icli()
! 52 #define isti()
! 53 #endif
! 54 
! 55 #ifdef ENDIS_BH
! 56 
! 57 #define init_bh(nr, routine) bh_base[nr] = routine; \
! 58             bh_mask_count[nr] = 0; \
! 59             bh_mask |= 1 << nr;
! 60 
! 61 #define disable_bh(nr) bh_mask &= ~(1 << nr); bh_mask_count[nr]++;
! 62 #define enable_bh(nr) if (!--bh_mask_count[nr]) bh_mask |= 1 << nr;
! 63 
! 64 #else
! 65 
! 66 #define init_bh(nr, routine) bh_base[nr] = routine;
! 67 
! 68 #endif
! 69 
! 70 #define mark_bh(nr) set_bit(nr, &bh_active);
! 71 
! 72 #endif /* __ARCH_8086_IRQ_H */
! 73 
! 73 
! 74 
! 5 
! 6 /*
! 7  * This file is generally used by user-level software, so you need to
! 8  * be a little careful about namespace pollution etc.  Also, we cannot
! 9  * assume GCC is being used.
! 10  */
! 11 
! 12 #undef	__FD_SET
! 13 #define __FD_SET(fd,fdsetp) \
! 14                 {\
! 15                 int     mask, retval,addr=fdsetp;\
! 16 						 \
! 17                 icli(); addr += fd >> 4;\
! 18                 mask = 1 << (fd & 0xf);\
! 19                 *(int*)addr |= mask; isti(); \
! 20                 }
! 21 
! 22 #undef	__FD_CLR
! 23 #define __FD_CLR(fd,fdsetp) \
! 24                 {\
! 25                 int     mask, retval,addr=fdsetp;\
! 26                                                  \
! 27                 icli(); addr += fd >> 4;\
! 28                 mask = 1 << (fd & 0xf);\
! 29                 *(int*)addr &= ~mask; isti(); \
! 30        	        }
! 31 
! 32 #undef	__FD_ISSET
! 33 #define __FD_ISSET(fd,fdsetp) ((((unsigned long *)fdsetp)[0] & (1<<(fd & 0x1f))) != 0)
! 34 
! 35 #undef	__FD_ZERO
! 36 #define __FD_ZERO(fdsetp) (((unsigned long *)fdsetp)[0] = 0UL)
! 37 
! 38 #endif /* __ARCH_8086_POSIZ_TYPES_H */
! 39 
! 39 
! 40 
! 54 
! 55 #endif /* _LINUXMT_POSIX_TYPES_H */
! 56 
! 56 
! 57 
! 6 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 11 #include <linuxmt/vfs.h>
! 1 
! 1 #ifndef __LINUX_VFS_H__
! 2 #define __LINUX_VFS_H__
! 3 
! 4 #include <arch/statfs.h>
! 1 
! 1 #ifndef __ARCH_8086_STATFS_H__
! 2 #define __ARCH_8086_STATFS_H__
! 3 
! 4 typedef struct {
! 5 	long    val[2];
! 6 } fsid_t;
! 7 
! 8 struct statfs {
! 9 	long f_type;
! 10 	long f_bsize;
! 11 	long f_blocks;
! 12 	long f_bfree;
! 13 	long f_bavail;
! 14 	long f_files;
! 15 	long f_ffree;
! 16 	fsid_t f_fsid;
! 17 	long f_namelen;
! 18 	long f_spare[6];
! 19 };
! 20 
! 21 #endif
! 22 
! 22 
! 23 
! 5 
! 6 #endif
! 7 
! 7 
! 8 
! 12 #include <linuxmt/kdev_t.h>
! 1 
! 1 #ifndef __LINUXMT_KDEV_T_H__
! 2 #define __LINUXMT_KDEV_T_H__
! 3 
! 4 #define MINORBITS	8
! 5 #define MINORMASK	((1<<MINORBITS) - 1)
! 6 
! 7 #ifdef __KERNEL__
! 8 
! 9 typedef __u16 kdev_t;
! 10 
! 11 #define MAJOR(dev)	((dev) >> MINORBITS)
! 12 #define MINOR(dev)	((dev) & MINORMASK)
! 13 #define HASHDEV(dev)	(dev)
! 14 #define NODEV		0
! 15 #define MKDEV(ma,mi)	(((ma) << MINORBITS) | (mi))
! 16 
! 17 extern char * kdevname();	/* note: returns pointer to static data! */
! 18 
! 19 /*
! 20 As long as device numbers in the outside world have 16 bits only,
! 21 we use these conversions.
! 22 */
! 23 
! 24 #define kdev_t_to_nr(dev)	(dev)
! 25 #define to_kdev_t(dev)		(dev)
! 26 
! 27 #else /* __KERNEL__ */
! 28 
! 29 /*
! 30 Some programs want their definitions of MAJOR and MINOR and MKDEV
! 31 from the kernel sources. These must be the externally visible ones.
! 32 */
! 33 #define MAJOR(dev)	((dev)>>MINORBITS)
! 34 #define MINOR(dev)	((dev) & MINORMASK)
! 35 #define MKDEV(ma,mi)	((ma)<<MINORBITS | (mi))
! 36 
! 37 #undef MINORBITS
! 38 #undef MINORMASK
! 39 #endif /* __KERNEL__ */
! 40 #endif
! 41 
! 41 
! 42 
! 13 #include <linuxmt/ioctl.h>
! 1 
! 1 #ifndef __LINUX_IOCTL_H__
! 2 #define __LINUX_IOCTL_H__
! 3 
! 4 #include <arch/ioctl.h>
! 1 
! 1 #ifndef __ARCH_8086_IOCTL_H__
! 2 #define __ARCH_8086_IOCTL_H__
! 3 
! 4 /*
! 5  *	Nothing here yet.
! 6  */
! 7 
! 8 #endif /* __ARCH_8086_IOCTL_H */
! 9 
! 9 
! 10 
! 5 
! 6 #endif /* _LINUX_IOCTL_H */
! 7 
! 8 
! 8 
! 9 
! 14 #include <linuxmt/pipe_fs_i.h>
! 1 
! 1 #ifndef __LINUX_PIPE_FS_I_H__
! 2 #define __LINUX_PIPE_FS_I_H__
! 3 
! 4 struct pipe_inode_info {
! 5 	struct wait_queue wait;
! 6 	char * base;
! 7 	unsigned int start;
! 8 	unsigned int len;
! 9 	unsigned int lock;
! 10 	unsigned int rd_openers;
! 11 	unsigned int wr_openers;
! 12 	unsigned int readers;
! 13 	unsigned int writers;
! 14 };
! 15 
! 16 #define PAGE_SIZE 512
! 17 #define PIPE_BUF 512
! 18 
! 19 #define PIPE_WAIT(inode)	((inode).u.pipe_i.wait)
! 20 #define PIPE_BASE(inode)	((inode).u.pipe_i.base)
! 21 #define PIPE_START(inode)	((inode).u.pipe_i.start)
! 22 #define PIPE_LEN(inode)		((inode).u.pipe_i.len)
! 23 #define PIPE_RD_OPENERS(inode)	((inode).u.pipe_i.rd_openers)
! 24 #define PIPE_WR_OPENERS(inode)	((inode).u.pipe_i.wr_openers)
! 25 #define PIPE_READERS(inode)	((inode).u.pipe_i.readers)
! 26 #define PIPE_WRITERS(inode)	((inode).u.pipe_i.writers)
! 27 #define PIPE_LOCK(inode)	((inode).u.pipe_i.lock)
! 28 #define PIPE_SIZE(inode)	PIPE_LEN(inode)
! 29 
! 30 #define PIPE_EMPTY(inode)	(PIPE_SIZE(inode)==0)
! 31 #define PIPE_FULL(inode)	(PIPE_SIZE(inode)==PIPE_BUF)
! 32 #define PIPE_FREE(inode)	(PIPE_BUF - PIPE_LEN(inode))
! 33 #define PIPE_END(inode)		((PIPE_START(inode)+PIPE_LEN(inode))&\
! 34 							   (PIPE_BUF-1))
! 35 #define PIPE_MAX_RCHUNK(inode)	(PIPE_BUF - PIPE_START(inode))
! 36 #define PIPE_MAX_WCHUNK(inode)	(PIPE_BUF - PIPE_END(inode))
! 37 
! 38 #endif
! 39 
! 39 
! 40 
! 15 #include <linuxmt/net.h>
! 1 
! 1 #ifndef __LINUXMT_NET_H__
! 2 #define __LINUXMT_NET_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 #include <linuxmt/wait.h>
! 1 
! 1 #ifndef __LINUX_WAIT_H__
! 2 #define __LINUX_WAIT_H__
! 3 
! 4 #define WNOHANG		0x00000001
! 5 #define WUNTRACED	0x00000002
! 6 
! 7 #define wake_up(_a) _wake_up(_a,1)
! 8 #define wake_up_interruptible(_a) _wake_up(_a,0)
! 9 
! 10 struct wait_queue {
! 11 	char pad;
! 12 };
! 13 
! 14 #ifdef __KERNEL__
! 15 
! 16 struct select_table_entry {
! 17 	struct wait_queue wait;
! 18 	struct wait_queue *wait_address;
! 19 };
! 20 
! 21 typedef struct select_table_struct {
! 22 	int nr;
! 23 	struct select_table_entry * entry;
! 24 } select_table;
! 25 
! 26 #define __MAX_SELECT_TABLE_ENTRIES 32
! 27 
! 28 #endif /* __KERNEL__ */
! 29 
! 30 #endif
! 31 
! 31 
! 32 
! 6 #include <linuxmt/socket.h>
! 1 
! 1 #ifndef __LINUXMT_SOCKET_H__
! 2 #define __LINUXMT_SOCKET_H__
! 3 
! 4 #include <linuxmt/uio.h>
! 1 
! 1 #ifndef __LINUXMT_UIO_H__
! 2 #define __LINUXMT_UIO_H__
! 3 
! 4 struct iovec
! 5 {
! 6 	void *iov_base;         /* BSD uses caddr_t (same thing in effect) */
! 7 	int iov_len;
! 8 };
! 9 
! 10 #define UIO_MAXIOV	16
! 11 
! 12 #endif /* _LINUXMT_UIO_H */
! 13 
! 13 
! 14 
! 5 
! 6 struct sockaddr
! 7 {
! 8 	unsigned short		sa_family;
! 9 	char			sa_data[14];
! 10 };
! 11 
! 12 struct msghdr
! 13 {
! 14 	void	*	msg_name;
! 15 	int		msg_namelen;
! 16 	struct iovec *	msg_iov;
! 17 	int		msg_iovlen;
! 18 	void	*	msg_control;
! 19 	int		msg_controllen;
! 20 	int		msg_flags;
! 21 };
! 22 
! 23 #define AF_INET	0	/* Only implemented type */
! 24 #define AF_UNIX	1
! 25 #define AF_NANO	2
! 26 
! 27 
! 28 #define PF_INET	AF_INET
! 29 #define PF_UNIX	AF_UNIX
! 30 #define PF_NANO	AF_NANO
! 31 
! 32 #define SOCK_STREAM     1               /* stream (connection) socket   */
! 33 #define SOCK_DGRAM      2               /* datagram (conn.less) socket  */
! 34 #define SOCK_RAW        3               /* raw socket                   */
! 35 #define SOCK_RDM        4               /* reliably-delivered message   */
! 36 #define SOCK_SEQPACKET  5               /* sequential packet socket     */
! 37 
! 38 
! 39 #endif /* LINUXMT_SOCKET_H */
! 40 
! 40 
! 41 
! 7 
! 8 /* Number of protocols */
! 9 #define NPROTO 3
! 10 
! 11 #define SOCK_INODE(S)	((S)->inode)
! 12 
! 13 typedef enum {
! 14 	SS_FREE = 0,
! 15 	SS_UNCONNECTED,
! 16 	SS_CONNECTING,
! 17 	SS_CONNECTED,
! 18 	SS_DISCONNECTING
! 19 } socket_state;
! 20 
! 21 struct socket {
! 22 	short			type;
! 23 	unsigned char		state;
! 24 	long			flags;
! 25 	struct proto_ops	*ops;
! 26 	void			*data;
! 27 #if defined(CONFIG_INET)
! 28 	int	avail_data;	/* I added this here for smaller code and memory use - HarKal */
! 29 	short  sem;
! 30 #endif
! 31 #if defined(CONFIG_UNIX) || defined(CONFIG_NANO) || defined(CONFIG_INET)
! 32 	struct socket		*conn;
! 33 	struct socket		*iconn;
! 34 	struct socket		*next;
! 35 #endif /* CONFIG_UNIX || CONFIG_NANO */
! 36 	struct wait_queue	*wait;
! 37 	struct inode		*inode;
! 38 	struct fasync_struct	*fasync_list;
! 39 	struct file		*file;
! 40 };
! 41 
! 42 struct proto_ops {
! 43 	int	family;
! 44 	int	(*create)	();
! 45 	int	(*dup)		();
! 46 	int	(*release)	();
! 47 	int	(*bind)		();
! 48 	int	(*connect)	();
! 49  	int	(*socketpair)	();
! 50 	int	(*accept)	();
! 51 	int	(*getname)	();
! 52 	int	(*read)		();
! 53 	int	(*write)	();
! 54 	int	(*select)	();
! 55 	int	(*ioctl)	();
! 56 	int	(*listen)	();
! 57 	int	(*send)		();
! 58 	int	(*recv)		();
! 59 	int	(*sendto)	();
! 60 	int	(*recvfrom)	();
! 61 	int	(*shutdown)	();
! 62 	int	(*setsocketopt)	();
! 63 	int	(*getsocketopt)	();
! 64 	int	(*fcntl)	();
! 65 };
! 66 
! 67 #define SO_ACCEPTCON	(1<<13)
! 68 #define SO_WAITDATA	(1<<14)
! 69 #define SO_NOSPACE	(1<<15)
! 70 
! 71 struct net_proto {
! 72 	char *name;               /* Protocol name */
! 73 	void (*init_func)();  /* Bootstrap */
! 74 };
! 75 
! 76 
! 77 #endif /* LINUXMT_NET_H */
! 78 
! 78 
! 79 
! 16 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 17 
! 18 #include <arch/bitops.h>
! 1 
! 1 #ifndef __ARCH_8086_BITOPS_H__
! 2 #define __ARCH_8086_BITOPS_H__
! 3 
! 4 extern int clear_bit();
! 5 extern int set_bit();
! 6 extern int test_bit();
! 7 
! 8 #endif
! 9 
! 9 
! 10 
! 19 
! 20 /*
! 21  * It's silly to have NR_OPEN bigger than NR_FILE, but I'll fix
! 22  * that later. Anyway, now the file code is no longer dependent
! 23  * on bitmaps in unsigned longs, but uses the new fd_set structure..
! 24  *
! 25  */
! 26  
! 27 #ifdef CONFIG_SHORT_FILES
! 28 #define NR_OPEN 	16
! 29 #else
! 30 #define NR_OPEN 	20
! 31 #endif
! 32 
! 33 #define NR_INODE	96	/* this should be bigger than NR_FILE */
! 34 #define NR_FILE 	64	/* this can well be larger on a larger system */
! 35 #define NR_SUPER	4
! 36 #define NR_EXT_BUFFERS	64	/* This may be assumed by some code! */
! 37 #define NR_MAPBUFS	8	/* Maximum number of mappable buffers */	
! 38 #define BLOCK_SIZE	1024
! 39 #define BLOCK_SIZE_BITS 10
! 40 
! 41 #ifdef CONFIG_FS_EXTERNAL_BUFFER
! 42 #define NR_BUFFERS NR_EXT_BUFFERS
! 43 #else
! 44 #define NR_BUFFERS NR_MAPBUFS
! 45 #endif
! 46 
! 47 #define MAY_EXEC 1
! 48 #define MAY_WRITE 2
! 49 #define MAY_READ 4
! 50 
! 51 #define FMODE_READ	1
! 52 #define FMODE_WRITE	2
! 53 
! 54 #define READ 0
! 55 #define WRITE 1
! 56 #define READA 2		/* read-ahead - don't pause */
! 57 #define WRITEA 3	/* "write-ahead" - silly, but somewhat useful */
! 58 
! 59 #define SEL_IN		1
! 60 #define SEL_OUT		2
! 61 #define SEL_EX		4
! 62 
! 63 /*
! 64  *	Passed to namei
! 65  */
! 66  
! 67 #define IS_DIR	1
! 68 #define NOT_DIR	2
! 69 
! 70 /*
! 71  * These are the fs-independent mount-flags: up to 16 flags are supported
! 72  */
! 73 
! 74 #define MS_RDONLY	 1 /* mount read-only */
! 75 #define MS_NOSUID	 2 /* ignore suid and sgid bits */
! 76 #define MS_NODEV	 4 /* disallow access to device special files */
! 77 #define MS_NOEXEC	 8 /* disallow program execution */
! 78 #define MS_SYNCHRONOUS	16 /* writes are synced at once */
! 79 #define MS_REMOUNT	32 /* alter flags of a mounted FS */
! 80 
! 81 #define S_APPEND    256 /* append-only file */
! 82 #define S_IMMUTABLE 512 /* immutable file */
! 83 
! 84 /*
! 85  * Flags that can be altered by MS_REMOUNT
! 86  */
! 87 #define MS_R
! 87 MT_MASK (MS_RDONLY)
! 88 
! 89 /*
! 90  * Executable formats
! 91  */
! 92 
! 93 #define EXEC_MINIX	0x1
! 94 #define EXEC_MSDOS	0x2
! 95 
! 96 /*
! 97  * Note that read-only etc flags are inode-specific: setting some file-system
! 98  * flags just means all the inodes inherit those flags by default. It might be
! 99  * possible to override it selectively if you really wanted to with some
! 100  * ioctl() that is not currently implemented.
! 101  *
! 102  * Exception: MS_RDONLY is always applied to the entire file system.
! 103  */
! 104 
! 105 #define IS_RDONLY(inode) (((inode)->i_sb) && ((inode)->i_sb->s_flags & MS_RDONLY))
! 106 #define IS_NOSUID(inode) ((inode)->i_flags & MS_NOSUID)
! 107 #define IS_NODEV(inode) ((inode)->i_flags & MS_NODEV)
! 108 #define IS_NOEXEC(inode) ((inode)->i_flags & MS_NOEXEC)
! 109 #define IS_SYNC(inode) ((inode)->i_flags & MS_SYNCHRONOUS)
! 110 
! 111 #define IS_APPEND(inode) ((inode)->i_flags & S_APPEND)
! 112 #define IS_IMMUTABLE(inode) ((inode)->i_flags & S_IMMUTABLE)
! 113 
! 114 #ifdef __KERNEL__
! 115 extern void buffer_init();
! 116 extern void inode_init();
! 117 
! 118 #ifndef CONFIG_FS_EXTERNAL_BUFFER
! 119 
! 120 #define map_buffer(_a)
! 121 #define unmap_buffer(_a)
! 122 #define unmap_brelse(_a) brelse(_a)
! 123 
! 124 #endif /* CONFIG_FS_EXTERNAL_BUFFER */
! 125 
! 126 
! 127 struct buffer_head
! 128 {
! 129 	char *b_data;		 /* Address in L1 buffer area */
! 130 	block_t b_blocknr;
! 131 	kdev_t b_dev;
! 132 	struct buffer_head *b_next;
! 133 	struct buffer_head *b_next_lru;
! 134 	unsigned int b_count;
! 135 	struct buffer_head *b_prev_lru;
! 136 	struct wait_queue b_wait;
! 137 	char b_uptodate, b_dirty, b_lock;	
! 138 	seg_t b_seg;
! 139 #ifdef CONFIG_FS_EXTERNAL_BUFFER
! 140 	unsigned char b_num;	 /* Used to lookup L2 area */
! 141 	unsigned int b_mapcount; /* Used for the new L2 buffer cache scheme */
! 142 #endif /* CONFIG_FS_EXTERNAL_BUFFER */
! 143 };
! 144 
! 145 #define BLOCK_READ	0
! 146 #define BLOCK_WRITE	1
! 147 
! 148 #define mark_buffer_dirty(bh, st) ((bh)->b_dirty = (st))
! 149 #define mark_buffer_clean(bh) ((bh)->b_dirty = 0)
! 150 #define buffer_dirty(bh) ((bh)->b_dirty)
! 151 #define buffer_clean(bh) (!(bh)->b_dirty)
! 152 #define buffer_uptodate(bh) ((bh)->b_uptodate)
! 153 #define buffer_locked(bh) ((bh)->b_lock)
! 154 
! 155 #define iget(_a, _b) __iget(_a, _b)
! 156 
! 157 extern void brelse();
! 158 extern void bforget();
! 159 /*extern struct inode *iget();
! 159 */
! 160 
! 161 /*
! 162  * Attribute flags.  These should be or-ed together to figure out what
! 163  * has been changed!
! 164  */
! 165 
! 166 #define ATTR_MODE	1
! 167 #define ATTR_UID	2
! 168 #define ATTR_GID	4
! 169 #define ATTR_SIZE	8
! 170 #define ATTR_ATIME	16
! 171 #define ATTR_MTIME	32
! 172 #define ATTR_CTIME	64
! 173 #define ATTR_ATIME_SET	128
! 174 #define ATTR_MTIME_SET	256
! 175 #define ATTR_FORCE	512
! 176 
! 177 /*
! 178  * This is the Inode Attributes structure, used for notify_change().  It
! 179  * uses the above definitions as flags, to know which values have changed.
! 180  * Also, in this manner, a Filesystem can look at only the values it cares
! 181  * about.  Basically, these are the attributes that the VFS layer can
! 182  * request to change from the FS layer.
! 183  *
! 184  * Derek Atkins <warlord@MIT.EDU> 94-10-20
! 185  */
! 186 struct iattr 
! 187 {
! 188 	unsigned int	ia_valid;
! 189 	umode_t		ia_mode;
! 190 	uid_t		ia_uid;
! 191 	gid_t		ia_gid;
! 192 	off_t		ia_size;
! 193 	time_t		ia_atime;
! 194 	time_t		ia_mtime;
! 195 	time_t		ia_ctime;
! 196 };
! 197 
! 198 #include <linuxmt/romfs_fs_i.h>
! 199 
! 200 struct inode 
! 201 {
! 202 	/* This stuff is on disk */
! 203 	__u16	i_mode;
! 204 	__u16	i_uid;
! 205 	__u32	i_size;
! 206 	__u32	i_mtime;
! 207 	__u8	i_gid;
! 208 	__u8	i_nlink;
! 209 	__u16	i_zone[9];
! 210 	/* This stuff is just in-memory... */
! 211 	ino_t		i_ino;
! 212 	kdev_t		i_dev;
! 213 	kdev_t		i_rdev;
! 214 	time_t		i_atime;
! 215 	time_t		i_ctime;
! 216 #ifdef BLOAT_FS
! 217 	unsigned long	i_blksize;
! 218 	unsigned long	i_blocks;
! 219 	unsigned long	i_version;
! 220 	unsigned short i_wcount;
! 221 	unsigned char i_seek;
! 222 	unsigned char i_update;
! 223 #endif
! 224 	struct inode_operations * i_op;
! 225 	struct super_block * i_sb;
! 226 	struct wait_queue i_wait;
! 227 	struct inode * i_next, * i_prev;
! 228 	struct inode * i_mount;
! 229 	unsigned short i_count;
! 230 	unsigned short i_flags;
! 231 	unsigned char i_lock;
! 232 	unsigned char i_dirt;
! 233 #ifdef CONFIG_PIPE
! 234 	unsigned char i_pipe;
! 235 #endif
! 236 	unsigned char i_sock;
! 237 	short i_sem;
! 238 	union {
! 239 		struct pipe_inode_info pipe_i;
! 240 		struct romfs_inode_info romfs_i;
! 241 		struct socket socket_i;
! 242 		void *generic_i;
! 243 	} u;
! 244 };
! 245 
! 246 struct file {
! 247 	mode_t f_mode;
! 248 	loff_t f_pos;
! 249 	unsigned short f_flags;
! 250 	unsigned short f_count;
! 251 	struct inode * f_inode;
! 252 	struct file_operations * f_op;
! 253 #ifdef BLOAT_FS
! 254 	off_t f_reada;
! 255 	unsigned long f_version;
! 256 	void *private_
! 256 data;	/* needed for tty driver, but not ntty */
! 257 #endif
! 258 };
! 259 
! 260 #include <linuxmt/minix_fs_sb.h>
! 261 #include <linuxmt/romfs_fs_sb.h>
! 262 #include <linuxmt/elksfs_fs_sb.h>
! 263 
! 264 struct super_block {
! 265 	kdev_t s_dev;
! 266 	unsigned char s_lock;
! 267 #ifdef BLOAT_FS
! 268 	unsigned char s_rd_only;
! 269 #endif
! 270 	unsigned char s_dirt;
! 271 	struct file_system_type *s_type;
! 272 	struct super_operations *s_op;
! 273 	unsigned int s_flags;
! 274 #ifdef BLOAT_FS
! 275 	unsigned long s_magic;
! 276 	unsigned long s_time;
! 277 #endif
! 278 	struct inode * s_covered;
! 279 	struct inode * s_mounted;
! 280 	struct wait_queue s_wait;
! 281 	union {
! 282 		struct minix_sb_info minix_sb;
! 283 		struct romfs_sb_info romfs_sb;
! 284 		struct elksfs_sb_info elksfs_sb;
! 285 		void *generic_sbp;
! 286 	} u;
! 287 };
! 288 
! 289 /*
! 290  * This is the "filldir" function type, used by readdir() to let
! 291  * the kernel specify what kind of dirent layout it wants to have.
! 292  * This allows the kernel to read directories into kernel space or
! 293  * to have different dirent layouts depending on the binary type.
! 294  */
! 295 
! 296 typedef int (*filldir_t)();
! 297 	
! 298 struct file_operations {
! 299 	int (*lseek) ();
! 300 	int (*read) ();
! 301 	int (*write) ();
! 302 	int (*readdir) ();
! 303 	int (*select) ();
! 304 	int (*ioctl) ();
! 305 	int (*open) ();
! 306 	void (*release) ();
! 307 #ifdef BLOAT_FS
! 308 	int (*fsync) ();
! 309 	int (*check_media_change) ();
! 310 	int (*revalidate) ();
! 311 #endif
! 312 };
! 313 
! 314 struct inode_operations {
! 315 	struct file_operations * default_file_ops;
! 316 	int (*create) ();
! 317 	int (*lookup) ();
! 318 	int (*link) ();
! 319 	int (*unlink) ();
! 320 	int (*symlink) ();
! 321 	int (*mkdir) ();
! 322 	int (*rmdir) ();
! 323 	int (*mknod) ();
! 324 	int (*readlink) ();
! 325 	int (*follow_link) ();
! 326 #ifdef BLOAT_FS
! 327 	int (*bmap) ();
! 328 #endif
! 329 	void (*truncate) ();
! 330 #ifdef BLOAT_FS
! 331 	int (*permission) ();
! 332 #endif
! 333 };
! 334 
! 335 struct super_operations {
! 336 	void (*read_inode) ();
! 337 #ifdef BLOAT_FS
! 338 	int (*notify_change) ();
! 339 #endif
! 340 	void (*write_inode) ();
! 341 	void (*put_inode) ();
! 342 	void (*put_super) ();
! 343 	void (*write_super) ();
! 344 #ifdef BLOAT_FS
! 345 	void (*statfs_kern) ();	/* i8086 statfs goes to kernel, then user */
! 346 #endif
! 347 	int (*remount_fs) ();
! 348 };
! 349 
! 350 struct file_system_type {
! 351 	struct super_block *(*read_super) ();
! 352 	char *name;
! 353 #ifdef BLOAT_FS
! 354 	int requires_dev
! 354 ;
! 355 #endif
! 356 };
! 357 
! 358 extern int event;		/* Event counter */
! 359 
! 360 extern int sys_open();
! 361 extern int sys_close();		/* yes, it's really unsigned */
! 362 extern void _close_allfiles();
! 363 
! 364 extern int register_blkdev();
! 365 extern int unregister_blkdev();
! 366 extern int blkdev_open();
! 367 extern struct file_operations def_blk_fops;
! 368 extern struct inode_operations blkdev_inode_operations;
! 369 
! 370 extern int register_chrdev();
! 371 extern int unregister_chrdev();
! 372 extern int chrdev_open();
! 373 extern struct file_operations def_chr_fops;
! 374 extern struct inode_operations chrdev_inode_operations;
! 375 
! 376 extern void init_fifo();
! 377 
! 378 extern struct file_operations connecting_fifo_fops;
! 379 extern struct file_operations read_fifo_fops;
! 380 extern struct file_operations write_fifo_fops;
! 381 extern struct file_operations rdwr_fifo_fops;
! 382 extern struct file_operations read_pipe_fops;
! 383 extern struct file_operations write_pipe_fops;
! 384 extern struct file_operations rdwr_pipe_fops;
! 385 
! 386 extern struct file_system_type *get_fs_type();
! 387 
! 388 extern int fs_may_mount();
! 389 extern int fs_may_umount();
! 390 extern int fs_may_remount_ro();
! 391 
! 392 extern struct file file_array[];
! 393 extern int nr_files;
! 394 extern struct super_block super_blocks[];
! 395 
! 396 extern void invalidate_inodes();
! 397 extern void invalidate_buffers();
! 398 extern void sync_inodes();
! 399 extern void sync_dev();
! 400 extern void fsync_dev();
! 401 extern void sync_supers();
! 402 extern int notify_change();
! 403 extern int namei();
! 404 #define lnamei(_a,_b) _namei(_a,NULL,0,_b)
! 405 
! 406 extern int permission();
! 407 #ifdef BLOAT_FS
! 408 extern int get_write_access();
! 409 extern void put_write_access();
! 410 #else 
! 411 #define get_write_access(_a)
! 412 #define put_write_access(_a)
! 413 #endif
! 414 extern int open_namei();
! 415 extern int do_mknod();
! 416 extern int do_pipe();
! 417 extern void iput();
! 418 extern struct inode * __iget();
! 419 extern struct inode * get_empty_inode();
! 420 extern void insert_inode_hash();
! 421 extern void clear_inode();
! 422 extern struct inode * get_pipe_inode();
! 423 extern struct file * get_empty_filp();
! 424 extern int close_fp();
! 425 extern struct buffer_head * get_hash_table();
! 426 extern struct buffer_head * getblk();
! 427 extern struct buffer_head * readbuf();
! 428 extern void ll_rw_blk();
! 429 exte
! 429 rn void ll_rw_page();
! 430 extern void ll_rw_swap_file();
! 431 
! 432 extern void map_buffer();
! 433 extern void unmap_buffer();
! 434 extern void unmap_brelse();
! 435 extern void print_bufmap_status();
! 436 
! 437 extern void put_super();
! 438 extern kdev_t ROOT_DEV;
! 439 
! 440 extern void show_buffers();
! 441 extern void mount_root();
! 442 
! 443 extern int char_read();
! 444 
! 445 #ifdef CONFIG_BLK_DEV_CHAR
! 446 extern int block_read();
! 447 extern int block_write();
! 448 #else
! 449 #define block_read NULL
! 450 #define block_write NULL
! 451 #endif
! 452 
! 453 #endif /* __KERNEL__ */
! 454 
! 455 #endif
! 456 
! 456 
! 457 
! 11 #include <linuxmt/time.h>
! 1 
! 1 #ifndef __LINUXMT_TIME_H__
! 2 #define __LINUXMT_TIME_H__
! 3 
! 4 #define DST_NONE        0       /* not on dst */
! 5 #define DST_USA         1       /* USA style dst */
! 6 #define DST_AUST        2       /* Australian style dst */
! 7 #define DST_WET         3       /* Western European dst */
! 8 #define DST_MET         4       /* Middle European dst */
! 9 #define DST_EET         5       /* Eastern European dst */
! 10 #define DST_CAN         6       /* Canada */
! 11 #define DST_GB          7       /* Great Britain and Eire */
! 12 #define DST_RUM         8       /* Rumania */
! 13 #define DST_TUR         9       /* Turkey */
! 14 #define DST_AUSTALT     10      /* Australian style with shift in 1986 */
! 15 
! 16 #ifdef __KERNEL__
! 17 
! 18 struct timeval {
! 19 	long		tv_sec;		/* seconds */
! 20 	long 		tv_usec;	/* microseconds */
! 21 };
! 22 
! 23 struct timezone {
! 24 	int	tz_minuteswest;	/* minutes west of Greenwich */
! 25 	int	tz_dsttime;	/* type of dst correction */
! 26 };
! 27 
! 28 #endif /* __KERNEL__ */
! 29 
! 30 #define NFDBITS                 __NFDBITS
! 31 
! 32 
! 33 #define FD_SETSIZE              __FD_SETSIZE
! 34 #define FD_SET(fd,fdsetp)       __FD_SET(fd,fdsetp)
! 35 #define FD_CLR(fd,fdsetp)       __FD_CLR(fd,fdsetp)
! 36 #define FD_ISSET(fd,fdsetp)     __FD_ISSET(fd,fdsetp)
! 37 #define FD_ZERO(fdsetp)         __FD_ZERO(fdsetp)
! 38 
! 39 #endif
! 40 
! 41 
! 41 
! 42 
! 12 #include <linuxmt/signal.h>
! 1 
! 1 #ifndef __LINUXMT_SIGNAL_H__
! 2 #define __LINUXMT_SIGNAL_H__
! 3 
! 4 /* The following signal mean nothing under ELKS currently
! 5  * SIGBUS SIGTRAP SIGIOT SIGEMT SIGSYS SIGSTKFLT SIGPOLL
! 6  * SIGCPU SIGPROF SIGPWR SIGILL SIGFPE
! 7  * 
! 8  * So we can have much tighter signal code if we have 16 bit signal
! 9  * mask by losing all these unused signals.
! 10  */
! 11 #define SMALLSIG
! 12 
! 13 #ifdef SMALLSIG
! 14 typedef unsigned short sigset_t;	/* at least 16 bits */
! 15 
! 16 #define _NSIG             16
! 17 #define NSIG		_NSIG
! 18 
! 19 #define SIGHUP		 1
! 20 #define SIGINT		 2
! 21 #define SIGQUIT		 3
! 22 #define SIGWINCH	 4
! 23 #define SIGSTOP		 5
! 24 #define SIGABRT		 6
! 25 #define SIGTSTP		 7
! 26 #define SIGCONT		 8
! 27 #define SIGKILL		 9
! 28 #define SIGUSR1		10
! 29 #define SIGSEGV		11
! 30 #define SIGCHLD		12
! 31 #define SIGPIPE		13
! 32 #define SIGALRM		14
! 33 #define SIGTERM		15
! 34 
! 35 #else /* SMALLSIG */
! 36 typedef unsigned long sigset_t;		/* at least 32 bits */
! 37 
! 38 #define _NSIG             32
! 39 #define NSIG		_NSIG
! 40 
! 41 #define SIGHUP		 1
! 42 #define SIGINT		 2
! 43 #define SIGQUIT		 3
! 44 #define SIGILL		 4
! 45 #define SIGTRAP		 5
! 46 #define SIGABRT		 6
! 47 #define SIGIOT		 6
! 48 #define SIGBUS		 7
! 49 #define SIGFPE		 8
! 50 #define SIGKILL		 9
! 51 #define SIGUSR1		10
! 52 #define SIGSEGV		11
! 53 #define SIGUSR2		12
! 54 #define SIGPIPE		13
! 55 #define SIGALRM		14
! 56 #define SIGTERM		15
! 57 #define SIGSTKFLT	16
! 58 #define SIGCHLD		17
! 59 #define SIGCONT		18
! 60 #define SIGSTOP		19
! 61 #define SIGTSTP		20
! 62 #define SIGTTIN		21
! 63 #define SIGTTOU		22
! 64 #define SIGURG		23
! 65 #define SIGXCPU		24
! 66 #define SIGXFSZ		25
! 67 #define SIGVTALRM	26
! 68 #define SIGPROF		27
! 69 #define SIGWINCH	28
! 70 #define SIGIO		29
! 71 #define SIGPOLL		SIGIO
! 72 #define SIGPWR		30
! 73 #define	SIGUNUSED	31
! 74 
! 75 #endif /* SMALLSIG */
! 76 
! 77 /*
! 78  * sa_flags values: SA_STACK is not supported
! 79  * SA_INTERRUPT is a no-op, but left due to historical reasons. Use the
! 80  * SA_RESTART flag to get restarting signals (which were the default long ago)
! 81  */
! 82 
! 83 #define SA_NOCLDSTOP	1
! 84 #define SA_STACK	0x08000000
! 85 #define SA_RESTART	0x10000000
! 86 #define SA_INTERRUPT	0x20000000
! 87 #define SA_NOMASK	0x40000000
! 88 #define SA_ONESHOT	0x80000000
! 89 
! 90 #ifdef __KERNEL__
! 91 /*
! 92  * These values of sa_flags are used only by the kernel as part of t
! 92 he
! 93  * irq handling routines.
! 94  *
! 95  * SA_INTERRUPT is also used by the irq handling routines.
! 96  */
! 97 #define SA_PROBE SA_ONESHOT
! 98 #define SA_SAMPLE_RANDOM SA_RESTART
! 99 #endif
! 100 
! 101 
! 102 #define SIG_BLOCK          0	/* for blocking signals */
! 103 #define SIG_UNBLOCK        1	/* for unblocking signals */
! 104 #define SIG_SETMASK        2	/* for setting the signal mask */
! 105 
! 106 /* Type of a signal handler.  */
! 107 typedef void (*__sighandler_t)();
! 108 
! 109 #define SIG_DFL	((__sighandler_t)0)	/* default signal handling */
! 110 #define SIG_IGN	((__sighandler_t)1)	/* ignore signal */
! 111 #define SIG_ERR	((__sighandler_t)-1)	/* error return from signal */
! 112 
! 113 struct sigaction {
! 114 	__sighandler_t sa_handler;
! 115 /*	sigset_t sa_mask; */
! 116 /*	unsigned long sa_flags; */
! 117 /*	void (*sa_restorer)(); */
! 118 };
! 119 
! 120 #endif
! 121 
! 121 
! 122 
! 13 #include <linuxmt/autoconf.h>
! 1 
! 1 /*
! 2  * Automatically generated by make menuconfig: don't edit
! 3  */
! 4 #define AUTOCONF_INCLUDED
! 5 
! 6 /*
! 7  * Advanced - for Developers and Hackers only
! 8  */
! 9 #undef  CONFIG_EXPERIMENTAL
! 10 #undef  CONFIG_OBSOLETE
! 11 #undef  CONFIG_NOT_YET
! 12 
! 13 /*
! 14  * Architecture
! 15  */
! 16 #define CONFIG_ARCH_AUTO 1
! 17 #undef  CONFIG_ARCH_IBMPC
! 18 #undef  CONFIG_ARCH_SIBO
! 19 #define CONFIG_PC_AUTO 1
! 20 #undef  CONFIG_PC_XT
! 21 #undef  CONFIG_PC_AT
! 22 #undef  CONFIG_PC_MCA
! 23 #undef  CONFIG_ROMCODE
! 24 
! 25 /*
! 26  * 286 Protected Mode Support
! 27  */
! 28 #undef  CONFIG_286PMODE
! 29 
! 30 /*
! 31  * Driver Support
! 32  */
! 33 
! 34 /*
! 35  * Character device drivers
! 36  */
! 37 #define CONFIG_CONSOLE_DIRECT 1
! 38 #undef  CONFIG_CONSOLE_BIOS
! 39 #undef  CONFIG_CONSOLE_SERIAL
! 40 #define CONFIG_DCON_VT52 1
! 41 #define CONFIG_DCON_ANSI 1
! 42 #undef  CONFIG_DCON_ANSI_PRINTK
! 43 #define CONFIG_KEYMAP_US 1
! 44 #undef  CONFIG_KEYMAP_BE
! 45 #undef  CONFIG_KEYMAP_UK
! 46 #undef  CONFIG_KEYMAP_DE
! 47 #undef  CONFIG_KEYMAP_DV
! 48 #undef  CONFIG_KEYMAP_ES
! 49 #undef  CONFIG_KEYMAP_FR
! 50 #undef  CONFIG_KEYMAP_SE
! 51 #define CONFIG_DCON_KRAW 1
! 52 #define CONFIG_CHAR_DEV_RS 1
! 53 #define CONFIG_CHAR_DEV_LP 1
! 54 #define CONFIG_CHAR_DEV_MEM 1
! 55 #define CONFIG_PSEUDO_TTY 1
! 56 #undef  CONFIG_DEV_META
! 57 
! 58 /*
! 59  * Block device drivers
! 60  */
! 61 #define CONFIG_BLK_DEV_BIOS 1
! 62 #define CONFIG_BLK_DEV_BFD 1
! 63 #define CONFIG_BLK_DEV_BHD 1
! 64 #undef  CONFIG_BLK_DEV_FD
! 65 #undef  CONFIG_BLK_DEV_HD
! 66 #undef  CONFIG_BLK_DEV_XD
! 67 #undef  CONFIG_DMA
! 68 #define CONFIG_GENDISK 1
! 69 #undef  CONFIG_BLK_DEV_RAM
! 70 #define CONFIG_BLK_DEV_CHAR 1
! 71 
! 72 /*
! 73  * Filesystems
! 74  */
! 75 #define CONFIG_MINIX_FS 1
! 76 #undef  CONFIG_ROMFS_FS
! 77 #undef  CONFIG_ELKSFS_FS
! 78 #undef  CONFIG_FULL_VFS
! 79 #define CONFIG_FS_EXTERNAL_BUFFER 1
! 80 #define CONFIG_PIPE 1
! 81 #define CONFIG_EXEC_MINIX 1
! 82 #undef  CONFIG_EXEC_MSDOS
! 83 
! 84 /*
! 85  * Network Support
! 86  */
! 87 #define CONFIG_SOCKET 1
! 88 #undef  CONFIG_NANO
! 89 #define CONFIG_INET 1
! 90 #define CONFIG_INET_STATUS 1
! 91 #undef  CONFIG_UNIX
! 92 #undef  CONFIG_SOCK_CLIENTONLY
! 93 
! 94 /*
! 95  * Kernel hacking
! 96  */
! 97 #undef  CONFIG_STRACE
! 98 #undef  CONFIG_OPT_SMALL
! 99 
! 99 
! 100 
! 14 #include <linuxmt/wait.h>
! 1 
! 1 #ifndef __LINUX_WAIT_H__
! 2 #define __LINUX_WAIT_H__
! 3 
! 4 #define WNOHANG		0x00000001
! 5 #define WUNTRACED	0x00000002
! 6 
! 7 #define wake_up(_a) _wake_up(_a,1)
! 8 #define wake_up_interruptible(_a) _wake_up(_a,0)
! 9 
! 10 struct wait_queue {
! 11 	char pad;
! 12 };
! 13 
! 14 #ifdef __KERNEL__
! 15 
! 16 struct select_table_entry {
! 17 	struct wait_queue wait;
! 18 	struct wait_queue *wait_address;
! 19 };
! 20 
! 21 typedef struct select_table_struct {
! 22 	int nr;
! 23 	struct select_table_entry * entry;
! 24 } select_table;
! 25 
! 26 #define __MAX_SELECT_TABLE_ENTRIES 32
! 27 
! 28 #endif /* __KERNEL__ */
! 29 
! 30 #endif
! 31 
! 31 
! 32 
! 15 #include <linuxmt/ntty.h>
! 1 
! 1 #ifndef __LINUX_TTY_H__
! 2 #define __LINUX_TTY_H__
! 3 
! 4 /*
! 5  * 'ntty.h' defines some structures used by ntty.c and some defines.
! 6  */
! 7 
! 8 #define INQ_SIZE 512
! 9 #define OUTQ_SIZE 64
! 10 
! 11 #define NUM_TTYS	6
! 12 
! 13 #define DCGET_GRAPH	(('D'<<8)+0x01)
! 14 #define DCREL_GRAPH	(('D'<<8)+0x02)
! 15 #define DCSET_KRAW	(('D'<<8)+0x03)
! 16 #define DCREL_KRAW	(('D'<<8)+0x04)
! 17 
! 18 #ifdef __KERNEL__
! 19 #include <linuxmt/fs.h>
! 20 #include <linuxmt/termios.h>
! 21 #include <linuxmt/chqueue.h>
! 22 
! 23 #include <arch/system.h>
! 24 
! 25 
! 26 /*
! 27  * Note: don't mess with NR_PTYS until you understand the tty minor 
! 28  * number allocation game...
! 29  * (Note: the *_driver.minor_start values 1, 64, 128, 192 are
! 30  * hardcoded at present.)
! 31  */
! 32  
! 33 #define NR_PTYS		4
! 34 
! 35 /* Not all of these will get used most likely */
! 36 
! 37 struct tty_ops {
! 38 	int (*open)();
! 39 	int (*release)();
! 40 	int (*write)();
! 41 	int (*read)();
! 42 	int (*ioctl)();
! 43 };
! 44 
! 45 struct tty {
! 46 	struct tty_ops *ops;
! 47 	int minor;
! 48 	int flags;
! 49 	unsigned char inq_buf[INQ_SIZE], outq_buf[OUTQ_SIZE];
! 50 /*	struct wait_queue *sleep; */
! 51 	struct ch_queue inq, outq;
! 52 	struct termios termios;
! 53 	pid_t pgrp;
! 54 };
! 55 
! 56 int ttynull_openrelease();	/* Empty function, returns zero. useful */
! 57 int tty_intcheck();		/* Check for ctrl-C etc.. */
! 58 extern int pipe_lseek();	/* Empty function, returns -ESPIPE. useful */
! 59 
! 60 extern struct termios def_vals; /* global use of def_vals                 */
! 61 
! 62 /* tty.flags */
! 63 #define TTY_STOPPED 	1
! 64 #define TTY_OPEN	2
! 65 
! 66 #endif /* __KERNEL__ */
! 67 #endif
! 68 
! 68 
! 69 
! 16 #include <arch/param.h>
! 1 
! 1 #ifndef __ARCH_8086_PARAM_H__
! 2 #define __ARCH_8086_PARAM_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 
! 6 #ifndef HZ
! 7 #ifdef CONFIG_ARCH_SIBO
! 8 
! 9 #define HZ 30
! 10 
! 11 #else /* CONFIG_ARCH_SIBO */
! 12 
! 13 #define HZ 100
! 14 
! 15 #endif /* CONFIG_ARCH_SIBO */
! 16 #endif /* HZ */
! 17 
! 18 #define EXEC_PAGESIZE	4096
! 19 
! 20 #ifndef NGROUPS
! 21 #define NGROUPS		32
! 22 #endif
! 23 
! 24 #ifndef NOGROUP
! 25 #define NOGROUP		(-1)
! 26 #endif
! 27 
! 28 #define MAXHOSTNAMELEN	64	/* max length of hostname */
! 29 
! 30 #endif /* _ARCH_8086_PARAM_H */
! 31 
! 31 
! 32 
! 17 #include <linuxmt/timex.h>
! 1 
! 1 #ifndef __LINUXMT_TIMEX_H__
! 2 #define __LINUXMT_TIMEX_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 
! 6 /*
! 7  *	We don't support the complex PLL time loops on Linux 8086
! 8  *	100Hz fixed is more than good enough for us.
! 9  */
! 10  
! 11 /*#define HZ 18*/
! 12 /* set to 100 HZ by Shani <kerr@wizard.net>, since that's what we're using! */
! 13 #ifdef CONFIG_ARCH_SIBO
! 14 
! 15 #define HZ 30
! 16 
! 17 #else /* CONFIG_ARCH_SIBO */
! 18 
! 19 #define HZ 100
! 20 
! 21 #endif /* CONFIG_ARCH_SIBO */
! 22 
! 23 #endif /* LINUXMT_TIMEX_H */
! 24 
! 24 
! 25 
! 18 #ifdef CONFIG_STRACE
! 19 #include <linuxmt/strace.h>
! 20 #endif
! 21 
! 22 struct file_struct
! 23 {
! 24 	fd_mask_t close_on_exec;
! 25 	struct file *fd[NR_OPEN];
! 26 };
! 27 
! 28 struct fs_struct {
! 29 	unsigned short umask;
! 30 	struct inode * root, * pwd;
! 31 };
! 32 
! 33 struct mm_struct {
! 34 	seg_t cseg,dseg;
! 35 	char flags;
! 36 #define CS_SWAP		1
! 37 #define DS_SWAP		2
! 38 };
! 39 
! 40 struct signal_struct {
! 41 	struct sigaction action[NSIG];
! 42 };
! 43 
! 44 struct task_struct 
! 45 {
! 46 /* Executive stuff */
! 47 	__registers t_regs;
! 48 	__pptr t_enddata, t_begstack, t_endbrk, t_endseg;
! 49 /* Kernel info */
! 50 	pid_t pid,ppid;
! 51 	pid_t session;
! 52 	uid_t uid,euid,suid;
! 53 	gid_t gid,egid,sgid;	
! 54 /* Scheduling + status variables */
! 55 	__s16 state;
! 56         __u32 timeout;                  /* for select() */
! 57 	struct wait_queue *waitpt;	/* Wait pointer */
! 58 	__u16 pollhash;
! 59 	struct task_struct *next_run, *prev_run;
! 60 	struct file_struct files;	/* File system structure */
! 61 	struct fs_struct fs;		/* File roots */
! 62 	struct mm_struct mm;		/* Memory blocks */
! 63 	pid_t pgrp;
! 64 	struct tty * tty;
! 65 /*	__u8 link_count;		/* Symlink loop counter, now global */
! 66 	struct task_struct *p_parent, *p_prevsib, *p_nextsib, *p_child;	 
! 67 	struct wait_queue child_wait;
! 68 	pid_t child_lastend;
! 69 	int lastend_status;
! 70 	struct inode * t_inode;
! 71 	sigset_t signal;		/* Signal status */
! 72 	struct signal_struct sig;	/* Signal block */
! 73 	int dumpable;			/* Can core dump */
! 74 #ifdef CONFIG_OLD_SCHED
! 75 	__uint t_count, t_priority;	/* priority scheduling elements */
! 76 	__s32 counter;			/* Time counter (unused so far) */
! 77         struct task_struct *next_task, *prev_task;
! 78 #endif /* CONFIG_OLD_SCHED */
! 79 #ifdef CONFIG_SUPPLEMENTARY_GROUPS
! 80 	gid_t groups[
! 80 NGROUPS];
! 81 #endif
! 82 #ifdef CONFIG_STRACE
! 83 	struct syscall_params sc_info;
! 84 #endif
! 85 	__u16 t_kstackm;	/* To detect stack corruption */
! 86 	__u8 t_kstack[KSTACK_BYTES];
! 87 };
! 88 
! 89 #define KSTACK_MAGIC 0x5476
! 90 
! 91 #define TASK_RUNNING 		0
! 92 #define TASK_INTERRUPTIBLE	1
! 93 #define TASK_UNINTERRUPTIBLE 	2
! 94 #define TASK_ZOMBIE		3
! 95 #define TASK_STOPPED		4
! 96 #define TASK_SWAPPING		5
! 97 #define TASK_UNUSED		6
! 98 #define TASK_WAITING		7
! 99 #define TASK_EXITING		8
! 100 
! 101 /* We use typedefs to avoid using struct foobar (*) */
! 102 typedef struct task_struct __task;
! 103 typedef struct task_struct * __ptask;
! 104 
! 105 extern __task task[MAX_TASKS];
! 106 
! 107 extern jiff_t jiffies;
! 108 extern __ptask current; /* next; */
! 109 extern int need_resched;
! 110 
! 111 extern struct timeval xtime;
! 112 #define CURRENT_TIME ((xtime.tv_sec) + (jiffies/HZ))
! 113 
! 114 #define for_each_task(p) \
! 115 	for (p = &task[0] ; p!=&task[MAX_TASKS]; p++ )
! 116 
! 117 #endif
! 118 
! 118 
! 119 
! 18 #include <unistd.h>
! 1 
! 1 /* unistd.h <ndf@linux.mit.edu> */
! 2 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 1 
! 1 
! 2 #ifndef __SYS_CDEFS_H
! 3 #define __SYS_CDEFS_H
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 
! 6 #if defined (__STDC__) && __STDC__
! 7 
! 8 #define	__CONCAT(x,y)	x ## y
! 9 #define	__STRING(x)	#x
! 10 
! 11 /* This is not a typedef so `const __ptr_t' does the right thing.  */
! 12 #define __ptr_t void *
! 13 typedef long double __long_double_t;
! 14 
! 15 #else
! 16 
! 17 #define	__CONCAT(x,y)	x/**/y
! 18 #define	__STRING(x)	"x"
! 19 
! 20 #define __ptr_t char *
! 21 
! 22 #ifndef __HAS_NO_FLOATS__
! 23 typedef double __long_double_t;
! 24 #endif
! 25 
! 26 #endif
! 27 
! 28 /* No C++ */
! 29 #define __BEGIN_DECLS
! 30 #define __END_DECLS
! 31 
! 32 /* GNUish things */
! 33 #define __CONSTVALUE
! 34 #define __CONSTVALUE2
! 35 
! 36 #endif
! 37 
! 37 
! 38 
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 3 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 4 
! 5 #ifndef __UNISTD_H
! 6 #define __UNISTD_H
! 7 
! 8 #define STDIN_FILENO 0
! 9 #define STDOUT_FILENO 1
! 10 #define STDERR_FILENO 2
! 11 
! 12 extern int close __P ((int));
! 13 extern size_t read __P ((int __fd, char * __buf, size_t __nbytes));
! 14 extern size_t write __P ((int __fd, __const char * __buf, size_t __n));
! 15 extern off_t lseek __P ((int __fd, off_t __n, int __whence));
! 16 extern int pipe __P ((int __pipedes[2]));
! 17 extern unsigned int alarm __P ((unsigned int __seconds));
! 18 extern unsigned int sleep __P ((unsigned int __seconds));
! 19 extern int pause __P ((void));
! 20 extern char*    crypt __P((__const char *__key, __const char *__salt));
! 21 
! 22 #ifndef SEEK_SET
! 23 #define SEEK_SET 0
! 24 #define SEEK_CUR 1
! 25 #define SEEK_END 2
! 26 #endif
! 27 
! 28 #ifndef R_OK
! 29 #define	R_OK	4		/* Test for read permission.  */
! 30 #define	W_OK	2		/* Test for write permission.  */
! 31 #define	X_OK	1		/* Test for execute permission.  */
! 32 #define	F_OK	0		/* Test for existence.  */
! 33 #endif
! 34 
! 35 #define _POSIX_VDISABLE	'\0'
! 36 
! 37 #endif /* __UNISTD_H */
! 38 
! 39 
! 40 
! 40 
! 41 
! 19 #include <fcntl.h>
! 1 
! 1 #ifndef __FCNTL__H
! 2 #define __FCNTL__H
! 3 
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 6 #include __SYSINC__(fcntl.h)
! 1 
! 1 #ifndef __LINUXMT_FCNTL_H__
! 2 #define __LINUXMT_FCNTL_H__
! 3 
! 4 /*
! 5  *	Definitions taken from the i386 Linux kernel.
! 6  */
! 7  
! 8 /* open/fcntl */
! 9 
! 10 #define O_ACCMODE	  0003
! 11 #define O_RDONLY	    00
! 12 #define O_WRONLY	    01
! 13 #define O_RDWR		    02
! 14 #define O_CREAT		  0100	/* not fcntl */
! 15 #define O_EXCL		  0200	/* not fcntl */
! 16 #define O_NOCTTY	  0400	/* not fcntl */
! 17 #define O_TRUNC		 01000	/* not fcntl */
! 18 #define O_APPEND	 02000
! 19 #define O_NONBLOCK	 04000
! 20 #define O_NDELAY	O_NONBLOCK
! 21 #if 0
! 22 #define O_SYNC		010000	/* Not supported */
! 23 #define FASYNC		020000	/* Not supported */
! 24 #endif
! 25 
! 26 #define F_DUPFD		0	/* dup */
! 27 #define F_GETFD		1	/* get f_flags */
! 28 #define F_SETFD		2	/* set f_flags */
! 29 #define F_GETFL		3	/* more flags (cloexec) */
! 30 #define F_SETFL		4
! 31 #define F_GETLK		5
! 32 #define F_SETLK		6
! 33 #define F_SETLKW	7
! 34 
! 35 #define F_SETOWN	8	/*  for sockets. */
! 36 #define F_GETOWN	9	/*  for sockets. */
! 37 
! 38 /* for F_[GET|SET]FL */
! 39 #define FD_CLOEXEC	1	/* actually anything with low bit set goes */
! 40 
! 41 /* for posix fcntl() and lockf() */
! 42 #define F_RDLCK		0
! 43 #define F_WRLCK		1
! 44 #define F_UNLCK		2
! 45 
! 46 /* for old implementation of bsd flock () */
! 47 #define F_EXLCK		4	/* or 3 */
! 48 #define F_SHLCK		8	/* or 4 */
! 49 
! 50 /* operations for bsd flock(), also used by the kernel implementation */
! 51 #define LOCK_SH		1	/* shared lock */
! 52 #define LOCK_EX		2	/* exclusive lock */
! 53 #define LOCK_NB		4	/* or'd with one of the above to prevent
! 54 				   blocking */
! 55 #define LOCK_UN		8	/* remove lock */
! 56 
! 57 #ifdef __KERNEL__
! 58 #define F_POSIX		1
! 59 #define F_FLOCK		2
! 60 #endif /* __KERNEL__ */
! 61 
! 62 #endif
! 63 
! 63 
! 64 
! 7 
! 8 #ifndef FNDELAY
! 9 #define FNDELAY	O_NDELAY
! 10 #endif
! 11 
! 12 __BEGIN_DECLS
! 13 
! 14 extern int creat __P ((__const char * __filename, mode_t __mode));
! 15 extern int fcntl __P ((int __fildes,int __cmd, ...));
! 16 extern int open __P ((__const char * __filename, int __flags, ...));
! 17 
! 18 __END_DECLS
! 19 
! 20 #endif
! 21 
! 21 
! 22 
! 20 #include <sys/stat.h>
! 1 
! 1 #ifndef _SYS_STAT_H
! 2 #define _SYS_STAT_H
! 3 
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 6 #include __SYSINC__(stat.h)
! 1 
! 1 #ifndef __LINUXMT_STAT_H__
! 2 #define __LINUXMT_STAT_H__
! 3 #include "types.h"
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 #include <arch/stat.h>
! 1 
! 1 #ifndef __ARCH_8086_STAT_H__
! 2 #define __ARCH_8086_STAT_H__
! 3 
! 4 struct stat {
! 5 	dev_t st_dev;
! 6 	ino_t st_ino;
! 7 	mode_t st_mode;
! 8 	nlink_t st_nlink;
! 9 	uid_t st_uid;
! 10 	gid_t st_gid;
! 11 	dev_t st_rdev;
! 12 	off_t st_size;
! 13 	time_t st_atime;
! 14 	time_t st_mtime;
! 15 	time_t st_ctime;
! 16 };
! 17 
! 18 #endif
! 19 
! 19 
! 20 
! 5 
! 6 #define S_IFMT  00170000
! 7 #define S_IFSOCK 0140000
! 8 #define S_IFLNK	 0120000
! 9 #define S_IFREG  0100000
! 10 #define S_IFBLK  0060000
! 11 #define S_IFDIR  0040000
! 12 #define S_IFCHR  0020000
! 13 #define S_IFIFO  0010000
! 14 #define S_ISUID  0004000
! 15 #define S_ISGID  0002000
! 16 #define S_ISVTX  0001000
! 17 
! 18 #define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
! 19 #define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
! 20 #define S_ISDIR(m)	(((m) & S_IFMT) == S_IFDIR)
! 21 #define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
! 22 #define S_ISBLK(m)	(((m) & S_IFMT) == S_IFBLK)
! 23 #define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
! 24 #define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)
! 25 
! 26 #define S_IRWXU 00700
! 27 #define S_IRUSR 00400
! 28 #define S_IWUSR 00200
! 29 #define S_IXUSR 00100
! 30 
! 31 #define S_IRWXG 00070
! 32 #define S_IRGRP 00040
! 33 #define S_IWGRP 00020
! 34 #define S_IXGRP 00010
! 35 
! 36 #define S_IRWXO 00007
! 37 #define S_IROTH 00004
! 38 #define S_IWOTH 00002
! 39 #define S_IXOTH 00001
! 40 
! 41 #ifdef __KERNEL__
! 42 #define S_IRWXUGO	(S_IRWXU|S_IRWXG|S_IRWXO)
! 43 #define S_IALLUGO	(S_ISUID|S_ISGID|S_ISVTX|S_IRWXUGO)
! 44 #define S_IRUGO		(S_IRUSR|S_IRGRP|S_IROTH)
! 45 #define S_IWUGO		(S_IWUSR|S_IWGRP|S_IWOTH)
! 46 #define S_IXUGO		(S_IXUSR|S_IXGRP|S_IXOTH)
! 47 #endif
! 48 
! 49 #endif
! 50 
! 50 
! 51 
! 7 
! 8 int stat __P((__const char * __path, struct stat * __statbuf));
! 9 int lstat __P((__const char * __path, struct stat * __statbuf));
! 10 int fstat __P((int __fd, struct stat * __statbuf));
! 11 
! 12 /* hysterical raisins */
! 13 #define S_IREAD		S_IRUSR /* read permission, owner */
! 14 #define S_IWRITE	S_IWUSR /* write permission, owner */
! 15 #define S_IEXEC		S_IXUSR /* execute/search permission, owner */
! 16 #endif
! 17 
! 17 
! 18 
! 21 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 22 #include <stdio.h>
! 1 
! 1 
! 2 #ifndef __STDIO_H
! 3 #define __STDIO_H
! 4 
! 5 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 6 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 7 
! 8 #ifndef SEEK_SET
! 9 #define SEEK_SET 0
! 10 #define SEEK_CUR 1
! 11 #define SEEK_END 2
! 12 #endif
! 13 
! 14 #define _IOFBF		0x00	/* full buffering */
! 15 #define _IOLBF		0x01	/* line buffering */
! 16 #define _IONBF		0x02	/* no buffering */
! 17 #define __MODE_BUF	0x03	/* Modal buffering dependent on isatty */
! 18 
! 19 #define __MODE_FREEBUF	0x04	/* Buffer allocated with malloc, can free */
! 20 #define __MODE_FREEFIL	0x08	/* FILE allocated with malloc, can free */
! 21 
! 22 #define __MODE_READ	0x10	/* Opened in read only */
! 23 #define __MODE_WRITE	0x20	/* Opened in write only */
! 24 #define __MODE_RDWR	0x30	/* Opened in read/write */
! 25 
! 26 #define __MODE_READING	0x40	/* Buffer has pending read data */
! 27 #define __MODE_WRITING	0x80	/* Buffer has pending write data */
! 28 
! 29 #define __MODE_EOF	0x100	/* EOF status */
! 30 #define __MODE_ERR	0x200	/* Error status */
! 31 #define __MODE_UNGOT	0x400	/* Buffer has been polluted by ungetc */
! 32 
! 33 #ifdef __MSDOS__
! 34 #define __MODE_IOTRAN	0x1000	/* MSDOS nl <-> cr,nl translation */
! 35 #else
! 36 #define __MODE_IOTRAN	0
! 37 #endif
! 38 
! 39 /* when you add or change fields here, be sure to change the initialization
! 40  * in stdio_init and fopen */
! 41 struct __stdio_file {
! 42   unsigned char *bufpos;   /* the next byte to write to or read from */
! 43   unsigned char *bufread;  /* the end of data returned by last read() */
! 44   unsigned char *bufwrite; /* highest address writable by macro */
! 45   unsigned char *bufstart; /* the start of the buffer */
! 46   unsigned char *bufend;   /* the end of the buffer; ie the byte after the last
! 47                               malloc()ed byte */
! 48 
! 49   int fd; /* the file descriptor associated with the stream */
! 50   int mode;
! 51 
! 52   char unbuf[8];	   /* The buffer for 'unbuffered' streams */
! 53 
! 54   struct __stdio_file * next;
! 55 };
! 56 
! 57 #define EOF	(-1)
! 58 #ifndef NULL
! 59 #define NULL	((void*)0)
! 60 #endif
! 61 
! 62 typedef struct __stdio_file FILE;
! 63 
! 64 #ifdef __AS386_16__
! 65 #define BUFSIZ	(256)
! 66 #else
! 67 #define BUFSIZ	(2048)
! 68 #endif
! 69 
! 70 extern FILE stdin[1];
! 71 extern FILE stdout[1];
! 72 extern FILE stderr[1];
! 73 
! 74 #ifdef __MSDOS__
! 75 #define putc(c, fp) fputc
! 75 (c, fp)
! 76 #define getc(fp) fgetc(fp)
! 77 #else
! 78 #define putc(c, stream)	\
! 79     (((stream)->bufpos >= (stream)->bufwrite) ? fputc((c), (stream))	\
! 80                           : (unsigned char) (*(stream)->bufpos++ = (c))	)
! 81 
! 82 #define getc(stream)	\
! 83   (((stream)->bufpos >= (stream)->bufread) ? fgetc(stream):		\
! 84     (*(stream)->bufpos++))
! 85 #endif
! 86 
! 87 #define putchar(c) putc((c), stdout)  
! 88 #define getchar() getc(stdin)
! 89 
! 90 #define ferror(fp)	(((fp)->mode&__MODE_ERR) != 0)
! 91 #define feof(fp)   	(((fp)->mode&__MODE_EOF) != 0)
! 92 #define clearerr(fp)	((fp)->mode &= ~(__MODE_EOF|__MODE_ERR),0)
! 93 #define fileno(fp)	((fp)->fd)
! 94 
! 95 /* declare functions; not like it makes much difference without ANSI */
! 96 /* RDB: The return values _are_ important, especially if we ever use
! 97         8086 'large' model
! 98  */
! 99 
! 100 /* These two call malloc */
! 101 #define setlinebuf(__fp)             setvbuf((__fp), (char*)0, _IOLBF, 0)
! 102 extern int setvbuf __P((FILE*, char*, int, size_t));
! 103 
! 104 /* These don't */
! 105 #define setbuf(__fp, __buf) setbuffer((__fp), (__buf), BUFSIZ)
! 106 extern void setbuffer __P((FILE*, char*, int));
! 107 
! 108 extern int fgetc __P((FILE*));
! 109 extern int fputc __P((int, FILE*));
! 110 
! 111 extern int fclose __P((FILE*));
! 112 extern int fflush __P((FILE*));
! 113 extern char *fgets __P((char*, size_t, FILE*));
! 114 extern FILE *__fopen __P((char*, int, FILE*, char*));
! 115 
! 116 #define fopen(__file, __mode)         __fopen((__file), -1, (FILE*)0, (__mode))
! 117 #define freopen(__file, __mode, __fp) __fopen((__file), -1, (__fp), (__mode))
! 118 #define fdopen(__file, __mode)  __fopen((char*)0, (__file), (FILE*)0, (__mode))
! 119 
! 120 extern int fputs __P((char*, FILE*));
! 121 extern int puts __P((char*));
! 122 
! 123 extern int printf __P ((__const char*, ...));
! 124 extern int fprintf __P ((FILE*, __const char*, ...));
! 125 extern int sprintf __P ((char*, __const char*, ...));
! 126 
! 127 #define stdio_pending(fp) ((fp)->bufread>(fp)->bufpos)
! 128 
! 129 #endif /* __STDIO_H */
! 130 
! 130 
! 131 
! 23 #include <pwd.h>
! 1 
! 1 #ifndef	__PWD_H
! 2 #define	__PWD_H
! 3 
! 4 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 5 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 6 #include <stdio.h>
! 1 
! 1 
! 2 #ifndef __STDIO_H
! 3 #define __STDIO_H
! 4 
! 5 #include <features.h>
! 6 #include <sys/types.h>
! 7 
! 8 #ifndef SEEK_SET
! 9 #define SEEK_SET 0
! 10 #define SEEK_CUR 1
! 11 #define SEEK_END 2
! 12 #endif
! 13 
! 14 #define _IOFBF		0x00	/* full buffering */
! 15 #define _IOLBF		0x01	/* line buffering */
! 16 #define _IONBF		0x02	/* no buffering */
! 17 #define __MODE_BUF	0x03	/* Modal buffering dependent on isatty */
! 18 
! 19 #define __MODE_FREEBUF	0x04	/* Buffer allocated with malloc, can free */
! 20 #define __MODE_FREEFIL	0x08	/* FILE allocated with malloc, can free */
! 21 
! 22 #define __MODE_READ	0x10	/* Opened in read only */
! 23 #define __MODE_WRITE	0x20	/* Opened in write only */
! 24 #define __MODE_RDWR	0x30	/* Opened in read/write */
! 25 
! 26 #define __MODE_READING	0x40	/* Buffer has pending read data */
! 27 #define __MODE_WRITING	0x80	/* Buffer has pending write data */
! 28 
! 29 #define __MODE_EOF	0x100	/* EOF status */
! 30 #define __MODE_ERR	0x200	/* Error status */
! 31 #define __MODE_UNGOT	0x400	/* Buffer has been polluted by ungetc */
! 32 
! 33 #ifdef __MSDOS__
! 34 #define __MODE_IOTRAN	0x1000	/* MSDOS nl <-> cr,nl translation */
! 35 #else
! 36 #define __MODE_IOTRAN	0
! 37 #endif
! 38 
! 39 /* when you add or change fields here, be sure to change the initialization
! 40  * in stdio_init and fopen */
! 41 struct __stdio_file {
! 42   unsigned char *bufpos;   /* the next byte to write to or read from */
! 43   unsigned char *bufread;  /* the end of data returned by last read() */
! 44   unsigned char *bufwrite; /* highest address writable by macro */
! 45   unsigned char *bufstart; /* the start of the buffer */
! 46   unsigned char *bufend;   /* the end of the buffer; ie the byte after the last
! 47                               malloc()ed byte */
! 48 
! 49   int fd; /* the file descriptor associated with the stream */
! 50   int mode;
! 51 
! 52   char unbuf[8];	   /* The buffer for 'unbuffered' streams */
! 53 
! 54   struct __stdio_file * next;
! 55 };
! 56 
! 57 #define EOF	(-1)
! 58 #ifndef NULL
! 59 #define NULL	((void*)0)
! 60 #endif
! 61 
! 62 typedef struct __stdio_file FILE;
! 63 
! 64 #ifdef __AS386_16__
! 65 #define BUFSIZ	(256)
! 66 #else
! 67 #define BUFSIZ	(2048)
! 68 #endif
! 69 
! 70 extern FILE stdin[1];
! 71 extern FILE stdout[1];
! 72 extern FILE stderr[1];
! 73 
! 74 #ifdef __MSDOS__
! 75 #define putc(c, fp) fputc
! 75 (c, fp)
! 76 #define getc(fp) fgetc(fp)
! 77 #else
! 78 #define putc(c, stream)	\
! 79     (((stream)->bufpos >= (stream)->bufwrite) ? fputc((c), (stream))	\
! 80                           : (unsigned char) (*(stream)->bufpos++ = (c))	)
! 81 
! 82 #define getc(stream)	\
! 83   (((stream)->bufpos >= (stream)->bufread) ? fgetc(stream):		\
! 84     (*(stream)->bufpos++))
! 85 #endif
! 86 
! 87 #define putchar(c) putc((c), stdout)  
! 88 #define getchar() getc(stdin)
! 89 
! 90 #define ferror(fp)	(((fp)->mode&__MODE_ERR) != 0)
! 91 #define feof(fp)   	(((fp)->mode&__MODE_EOF) != 0)
! 92 #define clearerr(fp)	((fp)->mode &= ~(__MODE_EOF|__MODE_ERR),0)
! 93 #define fileno(fp)	((fp)->fd)
! 94 
! 95 /* declare functions; not like it makes much difference without ANSI */
! 96 /* RDB: The return values _are_ important, especially if we ever use
! 97         8086 'large' model
! 98  */
! 99 
! 100 /* These two call malloc */
! 101 #define setlinebuf(__fp)             setvbuf((__fp), (char*)0, _IOLBF, 0)
! 102 extern int setvbuf __P((FILE*, char*, int, size_t));
! 103 
! 104 /* These don't */
! 105 #define setbuf(__fp, __buf) setbuffer((__fp), (__buf), BUFSIZ)
! 106 extern void setbuffer __P((FILE*, char*, int));
! 107 
! 108 extern int fgetc __P((FILE*));
! 109 extern int fputc __P((int, FILE*));
! 110 
! 111 extern int fclose __P((FILE*));
! 112 extern int fflush __P((FILE*));
! 113 extern char *fgets __P((char*, size_t, FILE*));
! 114 extern FILE *__fopen __P((char*, int, FILE*, char*));
! 115 
! 116 #define fopen(__file, __mode)         __fopen((__file), -1, (FILE*)0, (__mode))
! 117 #define freopen(__file, __mode, __fp) __fopen((__file), -1, (__fp), (__mode))
! 118 #define fdopen(__file, __mode)  __fopen((char*)0, (__file), (FILE*)0, (__mode))
! 119 
! 120 extern int fputs __P((char*, FILE*));
! 121 extern int puts __P((char*));
! 122 
! 123 extern int printf __P ((__const char*, ...));
! 124 extern int fprintf __P ((FILE*, __const char*, ...));
! 125 extern int sprintf __P ((char*, __const char*, ...));
! 126 
! 127 #define stdio_pending(fp) ((fp)->bufread>(fp)->bufpos)
! 128 
! 129 #endif /* __STDIO_H */
! 130 
! 130 
! 131 
! 7 
! 8 /* The passwd structure.  */
! 9 struct passwd
! 10 {
! 11   char *pw_name;		/* Username.  */
! 12   char *pw_passwd;		/* Password.  */
! 13   uid_t pw_uid;			/* User ID.  */
! 14   gid_t pw_gid;			/* Group ID.  */
! 15   char *pw_gecos;		/* Real name.  */
! 16   char *pw_dir;			/* Home directory.  */
! 17   char *pw_shell;		/* Shell program.  */
! 18 };
! 19 
! 20 
! 21 extern void setpwent __P ((void));
! 22 extern void endpwent __P ((void));
! 23 extern struct passwd * getpwent __P ((void));
! 24 
! 25 extern int putpwent __P ((__const struct passwd * __p, FILE * __f));
! 26 extern int getpw __P ((uid_t uid, char *buf));
! 27 
! 28 extern struct passwd * fgetpwent __P ((FILE * file));
! 29 
! 30 extern struct passwd * getpwuid __P ((__const uid_t));
! 31 extern struct passwd * getpwnam __P ((__const char *));
! 32 
! 33 #ifdef __LIBC__
! 34 extern struct passwd * __getpwent __P ((__const int passwd_fd));
! 35 #endif
! 36 
! 37 #endif /* pwd.h  */
! 38 
! 39 
! 40 
! 41 
! 41 
! 42 
! 24 
! 25 int read_task(fd, off, ds, task_table)
! 26 int fd;
export	_read_task
_read_task:
! 27 unsigned int off;
! 28 unsigned int ds;
! 29 struct task_struct * task_table;
! 30 {
! 31 	unsigned int i;
! 32 	off_t addr;
! 33 
! 34 	addr = (off_t) (((off_t)ds << 4) + off);
push	bp
mov	bp,sp
push	di
push	si
add	sp,*-6
mov	ax,6[bp]
xor	bx,bx
push	bx
push	ax
mov	ax,8[bp]
xor	bx,bx
mov	di,*4
call	lsll
lea	di,-$E[bp]
call	laddul
add	sp,*4
mov	-$A[bp],ax
mov	-8[bp],bx
! 35 	if (!(addr == lseek(fd, addr, SEEK_SET))) {
xor	ax,ax
push	ax
push	-8[bp]
push	-$A[bp]
push	4[bp]
call	_lseek
mov	bx,dx
add	sp,*8
lea	di,-$A[bp]
call	lcmpl
je  	.1
.2:
! 36 		return -1;
mov	ax,*-1
add	sp,*6
pop	si
pop	di
pop	bp
ret
! 37 	}
! 38 	if ((i = read(fd, task_table, sizeof (struct task_struct))) != (sizeof (struct task_struct))) {
.1:
mov	ax,#$4B8
push	ax
push	$A[bp]
push	4[bp]
call	_read
add	sp,*6
mov	-6[bp],ax
cmp	ax,#$4B8
je  	.3
.4:
! 39 		return -1;
mov	ax,*-1
add	sp,*6
pop	si
pop	di
pop	bp
ret
! 40 	}
! 41 }
.3:
add	sp,*6
pop	si
pop	di
pop	bp
ret
! 42 
! 43 int get_name(fd, seg, off)
! 44 int fd;
export	_get_name
_get_name:
! 45 unsigned int seg;
! 46 unsigned int off;
! 47 {
! 48 	int i, j;
! 49 	unsigned int strptr;
! 50 	off_t addr;
! 51 	int * d;
! 52 	char dbuf[64];
! 53 
! 54 	addr = (off_t) (((off_t)seg << 4) + (off_t)off);
push	bp
mov	bp,sp
push	di
push	si
add	sp,*-$4C
mov	ax,8[bp]
xor	bx,bx
push	bx
push	ax
mov	ax,6[bp]
xor	bx,bx
mov	di,*4
call	lsll
lea	di,-$54[bp]
call	laddl
add	sp,*4
mov	-$E[bp],ax
mov	-$C[bp],bx
! 55 	if (!(addr = lseek(fd, addr, SEEK_SET))) {
xor	ax,ax
push	ax
push	-$C[bp]
push	-$E[bp]
push	4[bp]
call	_lseek
mov	bx,dx
add	sp,*8
mov	-$E[bp],ax
mov	-$C[bp],bx
call	ltstl
jne 	.5
.6:
! 56 		return -1;
mov	ax,*-1
add	sp,*$4C
pop	si
pop	di
pop	bp
ret
! 57 	}
! 58 	if ((i = read(fd, &strptr, 2 )) != 2) {
.5:
mov	ax,*2
push	ax
lea	bx,-$A[bp]
push	bx
push	4[bp]
call	_read
add	sp,*6
mov	-6[bp],ax
cmp	ax,*2
je  	.7
.8:
! 59 		return -1;
mov	ax,*-1
add	sp,*$4C
pop	si
pop	di
pop	bp
ret
! 60 	}
! 61 	addr = (off_t) (((off_t)seg << 4) + (off_t)strptr);
.7:
mov	ax,-$A[bp]
xor	bx,bx
push	bx
push	ax
mov	ax,6[bp]
xor	bx,bx
mov	di,*4
call	lsll
lea	di,-$54[bp]
call	laddl
add	sp,*4
mov	-$E[bp],ax
mov	-$C[bp],bx
! 62 	if (!lseek(fd, addr, SEEK_SET)) {
xor	ax,ax
push	ax
push	-$C[bp]
push	-$E[bp]
push	4[bp]
call	_lseek
mov	bx,dx
add	sp,*8
call	ltstl
jne 	.9
.A:
! 63 		return -1;
mov	ax,*-1
add	sp,*$4C
pop	si
pop	di
pop	bp
ret
! 64 	}
! 65 	if ((i = read(fd, dbuf, 64 )) != 64) {
.9:
mov	ax,*$40
push	ax
lea	bx,-$50[bp]
push	bx
push	4[bp]
call	_read
add	sp,*6
mov	-6[bp],ax
cmp	ax,*$40
je  	.B
.C:
! 66 		return -1;
mov	ax,*-1
add	sp,*$4C
pop	si
pop	di
pop	bp
ret
! 67 	}
! 68 	printf("%s \n",dbuf);
.B:
lea	bx,-$50[bp]
push	bx
mov	bx,#.D
push	bx
call	_printf
add	sp,*4+$4C
pop	si
pop	di
pop	bp
ret
! 70 
! 71 
! 72 int main(argc, argv)
! 73 int argc;
export	_main
_main:
! 74 char ** argv;
! 75 {
.globl	___mkargv
! 76 	int i, fd;
! 77 	unsigned int j, ds, off;
! 78 	unsigned long addr;
! 79 	struct task_struct task_table;
! 80 	struct passwd * pwent;
! 81 
! 82 	if ((fd = open("/dev/kmem", O_RDONLY)) < 0) {
push	bp
mov	bp,sp
push	di
push	si
add	sp,#-$4C8
xor	ax,ax
push	ax
mov	bx,#.F
push	bx
call	_open
add	sp,*4
mov	-8[bp],ax
test	ax,ax
jge 	.E
.10:
! 83 		perror("ps");
mov	bx,#.11
push	bx
call	_perror
inc	sp
inc	sp
! 84 		exit(1);
mov	ax,*1
push	ax
call	_exit
inc	sp
inc	sp
! 85 	}
! 86 	if ((i = ioctl(fd, MEM_GETDS, &ds))) {
.E:
lea	bx,-$C[bp]
push	bx
mov	ax,*5
push	ax
push	-8[bp]
call	_ioctl
add	sp,*6
mov	-6[bp],ax
test	ax,ax
je  	.12
.13:
! 87 		perror("ps");
mov	bx,#.14
push	bx
call	_perror
inc	sp
inc	sp
! 88 		exit(1);
mov	ax,*1
push	ax
call	_exit
inc	sp
inc	sp
! 89 	}
! 90 	if ((i = ioctl(fd, MEM_GETTASK, &off))) {
.12:
lea	bx,-$E[bp]
push	bx
mov	ax,*2
push	ax
push	-8[bp]
call	_ioctl
add	sp,*6
mov	-6[bp],ax
test	ax,ax
je  	.15
.16:
! 91 		perror("ps");
mov	bx,#.17
push	bx
call	_perror
inc	sp
inc	sp
! 92 		exit(1);
mov	ax,*1
push	ax
call	_exit
inc	sp
inc	sp
! 93 	}
! 94 
! 95 	for (j = off, i = 0; i < 20; j += sizeof(struct task_struct), i++) {
.15:
mov	ax,-$E[bp]
mov	-$A[bp],ax
xor	ax,ax
mov	-6[bp],ax
br 	.1A
.1B:
! 96 		if (read_task(fd, j, ds, &task_table) == -1) {
lea	bx,-$4CA[bp]
push	bx
push	-$C[bp]
push	-$A[bp]
push	-8[bp]
call	_read_task
add	sp,*8
cmp	ax,*-1
jne 	.1C
.1D:
! 97 			perror("ps");
mov	bx,#.1E
push	bx
call	_perror
inc	sp
inc	sp
! 98 			exit(1);
mov	ax,*1
push	ax
call	_exit
inc	sp
inc	sp
! 99 		}
! 100 		if (task_table.t_kstackm != KSTACK_MAGIC) {
.1C:
cmp	word ptr -$414[bp],#$5476
je  	.1F
.20:
! 101 			break;
br 	.18
! 102 		}
! 103 		if (task_table.t_regs.ss == 0) {
.1F:
mov	ax,-$4C6[bp]
test	ax,ax
jne 	.21
.22:
! 104 			continue;
jmp .19
! 105 		}
! 106 		if (task_table.state != TAS
.21:
! 106 K_UNUSED) {
cmp	word ptr -$492[bp],*6
je  	.23
.24:
! 107 			pwent = (getpwuid(task_table.uid));
push	-$49E[bp]
call	_getpwuid
inc	sp
inc	sp
mov	-$4CC[bp],ax
! 108 			printf("%d %d %s %c %u ", 
! 109 				task_table.pid,
! 110 				task_table.pgrp,
! 111 				(pwent ? pwent->pw_name : "unknown"),
! 112 				((task_table.state == TASK_RUNNING) ? 'R' : 'S'),
! 113 				task_table.t_inode);
push	-$43A[bp]
mov	ax,-$492[bp]
test	ax,ax
jne 	.27
.28:
mov	al,*$52
jmp .29
.27:
mov	al,*$53
.29:
xor	ah,ah
push	ax
mov	ax,-$4CC[bp]
test	ax,ax
je  	.2A
.2B:
mov	bx,-$4CC[bp]
mov	bx,[bx]
jmp .2C
.2A:
mov	bx,#.26
.2C:
push	bx
push	-$44C[bp]
push	-$4A4[bp]
mov	bx,#.25
push	bx
call	_printf
add	sp,*$C
! 114 			get_name(fd, task_table.t_regs.ss, task_table.t_begstack + 2);
mov	ax,-$4AA[bp]
inc	ax
inc	ax
push	ax
push	-$4C6[bp]
push	-8[bp]
call	_get_name
add	sp,*6
! 115 			fflush(stdout);
mov	bx,#_stdout
push	bx
call	_fflush
inc	sp
inc	sp
! 116 		}
! 117 	}
.23:
! 118 	exit(0);
.19:
mov	ax,-$A[bp]
add	ax,#$4B8
mov	-$A[bp],ax
inc	word ptr -6[bp]
.1A:
cmp	word ptr -6[bp],*$14
blt 	.1B
.2D:
.18:
xor	ax,ax
push	ax
call	_exit
inc	sp
inc	sp
! 119 }
lea	sp,-4[bp]
pop	si
pop	di
pop	bp
ret
! 120 
! 121 
.data
.26:
.2E:
.ascii	"unknown"
.byte	0
.25:
.2F:
.ascii	"%d %d %s %c %u "
.byte	0
.1E:
.30:
.ascii	"ps"
.byte	0
.17:
.31:
.ascii	"ps"
.byte	0
.14:
.32:
.ascii	"ps"
.byte	0
.11:
.33:
.ascii	"ps"
.byte	0
.F:
.34:
.ascii	"/dev/kmem"
.byte	0
.D:
.35:
.ascii	"%s "
.byte	$A
.byte	0
.bss
! 0 errors detected
